    # -*- coding: utf-8 -*-
import sqlite3
	
class DataBaseManagement(object):	
    connection = sqlite3.connect("quiz.db")
    cursor = connection.cursor()
    def __init__(self):
        #Check if database already exists
        self.cursor.execute("SELECT * FROM sqlite_master WHERE type='table'")
        self.DBExists = self.cursor.fetchall()
			
        if not self.DBExists:
            #Database doesn't exist yet
            #create it
            self.cursor.execute("""CREATE TABLE quiz (
			id INTEGER, name TEXT, active INTEGER)""")
			
            self.cursor.execute("""CREATE TABLE questions (
			id INTEGER , question TEXT, answer TEXT, quiz_id INTEGER, active INTEGER )""")
			
            self.cursor.execute("""CREATE TABLE question_statistics (
			id INTEGER, asked INTEGER, right_answered INTEGER )""")
				
            self.cursor.execute("""CREATE TABLE quiz_statistics (
			id INTEGER , quiz_id INTEGER, quiz_started INTEGER, quiz_success INTEGER )""")
			
			
            #create an example quiz
            werte = {"id": "1", "name": "Example - Capitals and Countries", "active":"1"}
            sql = "INSERT INTO quiz (id, name, active) VALUES (:id, :name, :active)"
            self.cursor.execute(sql, werte)
            self.connection.commit()
				
            werte = {"id": "1", "question": "What is the capital of Switzerland?", "answer": "Bern", "quiz_id": "1", "active": "1"}
            sql = "INSERT INTO questions (id, question, answer, quiz_id, active) VALUES(:id, :question, :answer, :quiz_id, :active)"
            self.cursor.execute(sql, werte)
            self.connection.commit()
			
            werte = {"id": "1", "asked": "0", "right_answered":"0"}
            sql = "INSERT INTO question_statistics (id, asked, right_answered) VALUES (:id, :asked, :right_answered)"
            self.cursor.execute(sql, werte)
            self.connection.commit()
			
            werte = {"id": "2", "question": "What is the capital of France?", "answer": "Paris", "quiz_id": "1", "active": "1"}
            sql = "INSERT INTO questions (id, question, answer, quiz_id, active) VALUES(:id, :question, :answer, :quiz_id, :active)"
            self.cursor.execute(sql, werte)
            self.connection.commit()
			
            werte = {"id": "2", "asked": "0", "right_answered":"0"}
            sql = "INSERT INTO question_statistics (id, asked, right_answered) VALUES (:id, :asked, :right_answered)"
            self.cursor.execute(sql, werte)
            self.connection.commit()
			
            werte = {"id": "3", "question": "What is the capital of Spain?", "answer": "Madrid", "quiz_id": "1", "active": "1"}
            sql = "INSERT INTO questions (id, question, answer, quiz_id, active) VALUES(:id, :question, :answer, :quiz_id, :active)"
            self.cursor.execute(sql, werte)
            self.connection.commit()
			
            werte = {"id": "3", "asked": "0", "right_answered":"0"}
            sql = "INSERT INTO question_statistics (id, asked, right_answered) VALUES (:id, :asked, :right_answered)"
            self.cursor.execute(sql, werte)
            self.connection.commit()
				
    def getQuizList(self):
        self.cursor.execute("SELECT * FROM quiz WHERE active = 1")
        return self.cursor.fetchall()
 			
    def getQuestions(self, QuizID):
        strSQL = "SELECT * FROM questions WHERE quiz_id='"
        strSQL = strSQL + str(QuizID)
        strSQL = strSQL + "'"
        self.cursor.execute(strSQL)
        return self.cursor.fetchall()
 	
    def getIDbyName(self, Name):
        strSQL = "SELECT id FROM quiz WHERE name='"
        strSQL = strSQL + Name
        strSQL = strSQL + "'"
        self.cursor.execute(str(strSQL))
        return self.cursor.fetchall()
	 	
    def InsertData(self, QuestionID, QuizID, Question, Answer):
        werte = {"id": QuestionID, "question": str(Question), "answer": str(Answer), "quiz_id": QuizID, "active": "1"}
        sql = "INSERT INTO questions (id, question, answer, quiz_id, active) VALUES(:id, :question, :answer, :quiz_id, :active)"
        self.cursor.execute(sql, werte)
        self.connection.commit()
	 	
    def getQuizIDs(self):
        self.cursor.execute("SELECT id FROM quiz")
        return self.cursor.fetchall()
	 	
    def getQuestionIDs(self):
        self.cursor.execute("SELECT id FROM questions")
        return self.cursor.fetchall()
	 			
    def WriteNewQuizName(self, QuizID, QuizName):
        werte = {"id": QuizID, "name": str(QuizName), "active": "1"}
        sql = "INSERT INTO quiz (id, name, active) VALUES (:id, :name, :active)"
        self.cursor.execute(sql, werte)
        self.connection.commit()
 	
    def DeleteQuizByID(self, ID):
        #strSQL = "DELETE FROM quiz WHERE id='"
        strSQL = "UPDATE quiz SET active = 0 WHERE id='"
        strSQL = strSQL + str(ID)
        strSQL = strSQL + "'"
        self.cursor.execute(strSQL)
        self.connection.commit()
		
    def deleteQuestionsByQuizID(self, ID):
        #strSQL = "DELETE FROM questions WHERE id='"
        strSQL = "UPDATE questions SET active = 0 WHERE id='"
        strSQL = strSQL + str(ID)
        strSQL = strSQL + "'"
        self.cursor.execute(strSQL)
        self.connection.commit()
		
    def increaseAsked(self, QuestionID):
        strSQL = "UPDATE question_statistics SET asked = asked + 1 WHERE id = '"
        strSQL = strSQL + str(QuestionID)
        strSQL = strSQL + "'"
        self.cursor.execute(strSQL)
        self.connection.commit()
		
    def increaseRightAnswered(self, QuestionID):
        strSQL = "UPDATE question_statistics SET right_answered = right_answered + 1 WHERE id = '"
        strSQL = strSQL + str(QuestionID)
        strSQL = strSQL + "'"
        self.cursor.execute(strSQL)
        self.connection.commit()
		
    def getStage(self, questionID):
        strSQL = "SELECT right_answered FROM question_statistics WHERE id='"
        strSQL = strSQL + questionID
        strSQL = strSQL + "'"
        self.cursor.execute(strSQL)
        return self.cursor.fetchall()
		
    def addQuestionToStats(self, questionID):
        werte = {"id": questionID, "asked": "0", "right_answered":"0"}
        sql = "INSERT INTO question_statistics (id, asked, right_answered) VALUES (:id, :asked, :right_answered)"
        self.cursor.execute(sql, werte)
        self.connection.commit()
		
    def changeQuestion(self, questionID, newQuestion):
        strSQL = "UPDATE questions SET question = '"
        strSQL = strSQL + str(newQuestion)
        strSQL = strSQL + "WHERE id = '"
        strSQL = strSQL + str(questionID)
        strSQL = strSQL + "'"
        self.cursor.execute(strSQL)
        self.connection.commit()
	
    def changeAnswer(self, questionID, newAnswer):
        strSQL = "UPDATE questions SET answer = '"
        strSQL = strSQL + str(newAnswer)
        strSQL = strSQL + "WHERE id = '"
        strSQL = strSQL + str(questionID)
        strSQL = strSQL + "'"
        self.cursor.execute(strSQL)
        self.connection.commit()