#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
import webbrowser

from DataBaseAccess import *
from ExportController import *
from MainWindow import *
from PyQt4 import QtCore
from PyQt4 import QtGui
from QuizController import *
from createQuizController import *

class MainWindowController(QtGui.QMainWindow):
	def __init__(self, parent=None):
		QtGui.QWidget.__init__(self, parent)
		self.mW = Ui_MainWindow()
		self.dBA = DataBaseManagement()
		
		self.mW.setupUi(self)
		#Fill Quiz List
		QuizList = self.dBA.getQuizList()
		if not QuizList:
			item = "There is no Quiz yet"
		else:
			intIterator = 0
			for rows in QuizList:
				item = QuizList[intIterator]
				self.mW.listWidget.addItem(item[1])
				intIterator = intIterator + 1
				
		#Connect Signals with accurate actions
		self.connect(self.mW.listWidget,QtCore.SIGNAL("itemDoubleClicked(QListWidgetItem*)"), self.startQuiz)
		self.connect(self.mW.listWidget,QtCore.SIGNAL("itemClicked(QListWidgetItem*)"), self.getStages)
		self.connect(self.mW.pushButton,QtCore.SIGNAL('clicked()'), self.reloadList)
		
		self.connect(self.mW.menuMenu,QtCore.SIGNAL('triggered(QAction *)'), self.menuHandler)
		
		#Set initial Value to zero
		self.mW.progressBar.setValue(0)		
		self.mW.progressBar_2.setValue(0)		
		self.mW.progressBar_3.setValue(0)

	def menuHandler(self, action):
		if action.text() == "Add new ...":
			self.addNewQuiz()
			
		if action.text() == "Delete selected":
			self.deleteQuiz()
			
		if action.text() == "About":
			webbrowser.open("http://wtlw.bgaechter.ch", 1)
			
		if action.text() == "Modify ...":
			pass			
			
		if action.text() == "Export selected":
			self.eXW = ExportController()
			self.eXW.setQuizName(self.selectedItem.text())
			
	def deleteQuiz(self):
		quizIDArray = self.dBA.getIDbyName(self.selectedItem.text())
		quizID = quizIDArray[0]
		self.dBA.DeleteQuizByID(quizID[0])
		self.dBA.deleteQuestionsByQuizID(quizID[0])
		
	def addNewQuiz(self):
		self.cqC = createQuizController()
		self.reloadList()
			
	def reloadList(self):
		self.mW.listWidget.clear()
		QuizList = self.dBA.getQuizList()
		if not QuizList:
			item = "There is no Quiz yet"
		else:
			intIterator = 0
			for rows in QuizList:
				item = QuizList[intIterator]
				self.mW.listWidget.addItem(item[1])
				intIterator = intIterator + 1
		
		
	def startQuiz(self, item):
		self.qC = QuizController()
		self.qC.doQuiz(item.text())
		
	def getStages(self, item):
		
		#sometimes needed for delete function
		self.selectedItem = item
		
		intCounter = 1
		stage = 0
		stage1 = 0
		stage2 = 0
		stage3 = 0
		
		quizIDArray = self.dBA.getIDbyName(item.text())
		quizID = quizIDArray[0]
		questionsList = self.dBA.getQuestions(quizID[0])
		for lines in questionsList:
			intCounter = intCounter + 1
			uStage = self.dBA.getStage(str(lines[0]))
			if not uStage:
				return 0
				
			stage = uStage[0]
			if(stage[0] == 0):
				stage1 = stage1 +1
			if(stage[0] == 1):
				stage2 = stage2 +1
			if(stage[0] >= 2):
				stage3 = stage3 +1
		
		if stage1 == 0 and stage2 == 0 and stage3 ==0:
		    self.mW.progressBar.setValue(0)		
		    self.mW.progressBar_2.setValue(0)		
		    self.mW.progressBar_3.setValue(0)
		else:
		    self.mW.progressBar.setValue(100/(stage1+stage2+stage3)*stage1)		
		    self.mW.progressBar_2.setValue(100/(stage1+stage2+stage3)*stage2)		
		    self.mW.progressBar_3.setValue(100/(stage1+stage2+stage3)*stage3)
			

if __name__ == "__main__":
	app = QtGui.QApplication(sys.argv)
	wtlw = MainWindowController()
	wtlw.show()
	sys.exit(app.exec_())
